#ifndef PV_GET_H
#define PV_GET_H

#include <libpv_config.h>

#include <inttypes.h>

#include <pv_types.h>
#include <pv_register.h>

static inline uint8_t pv_get_uint8	(const struct pv_engine	*engine,
					 const struct pv	*pv)
{
	return *(pv_to_abs_addr(engine, pv)->u8);
}

static inline int8_t pv_get_int8	(const struct pv_engine	*engine,
					 const struct pv	*pv)
{
	return *(pv_to_abs_addr(engine, pv)->s8);
}


static inline uint16_t pv_get_uint16	(const struct pv_engine	*engine,
					 const struct pv	*pv)
{
	return *(pv_to_abs_addr(engine, pv)->u16);
}

static inline int16_t pv_get_int16	(const struct pv_engine	*engine,
					 const struct pv	*pv)
{
	return *(pv_to_abs_addr(engine, pv)->s16);
}


static inline uint32_t pv_get_uint32	(const struct pv_engine	*engine,
					 const struct pv	*pv)
{
	return *(pv_to_abs_addr(engine, pv)->u32);
}

static inline int32_t pv_get_int32	(const struct pv_engine	*engine,
					 const struct pv	*pv)
{
	return *(pv_to_abs_addr(engine, pv)->s32);
}


static inline uint64_t pv_get_uint64	(const struct pv_engine	*engine,
					 const struct pv	*pv)
{
	return *(pv_to_abs_addr(engine, pv)->u64);
}

static inline int64_t pv_get_int64	(const struct pv_engine	*engine,
					 const struct pv	*pv)
{
	return *(pv_to_abs_addr(engine, pv)->s64);
}

#endif	/* !PV_GET_H */
